import java.awt.Color;
/**
 * Problem 1.a:   (5 pts) What depends on the state?
 * Of the methods of the Roommate class, getEyeColor(), eat(), getGreeting() and study(), 
 * which depend on the state of the roommate?   Explain your reasoning.
 * Write your answers below:
 * 
 * State dependent: eat, study and getGreeting because their results change depending on 
 * what has happened to the Roommate object.
 * 
 * State-independent:  getEyeColor, because it always returns the same value, no matter 
 * what has happened.
 * 
 * Problem 1.b:  (5 pts) The States of a Roommate:  
 * From the above test code, how many states do your think a Roommate has?   
 * Describe the states. 
 * Write your answers below:
 * 
 * There are 4 states:
 * 1) asleep - Roommate is greets with "Zzzzz....", does nothing when eats or study.  
 * Greeting causes state change to grumpy.
 * 2) grumpy -- Greets with "Go away!".  Study has no effect. Greeting has no state change.
 * Eating changes state to energized.
 * 3) energized -- Greets with "What a great day!" with no state change.  Eating changes state 
 * to sleepy. Studying more than 3 hours changes the state to sleepy. 
 * 4) sleepy -- Greets with "Huh? Where am I?" and no state change.  Eat and study both change
 * state to asleep.
 * 
 * 
 */
public class Roommate {
  
  /**
   * Abstract state of a Roommate
   */
  private static abstract class AState {
    // STUDENT TO COMPLETE (Problem 1.c)
    abstract String getGreeting();
    abstract void eat();
    abstract void study(int hours);
  }
  
  // STUDENT TO IMPLEMENT CONCRETE STATES 
  // USING ANONYMOUS INNER CLASSES (Problem 1.d)
  
  private AState _asleep = new AState() {
    void eat() {
    }
    
    String getGreeting() {
      _state = _grumpy;
      return "Zzzzzzz....";
    }
    
    void study(int hours) {
    }
  };
  
  private AState _grumpy = new AState() {
    void eat() {
      _state = _energized;
    }
    
    String getGreeting() {
      return "Go away!";
    }
    
    void study(int hours) {
    }
  };
  
  private AState _energized = new AState() {
    void eat() {
      _state = _sleepy;
    }
    
    String getGreeting() {
      return "What a great day!";
    }
    
    void study(int hours) {
      if(hours>3) {
        _state = _sleepy;
      }
    }
  };  
  
  
  private AState _sleepy = new AState() {
    void eat() {
      _state = _asleep;
    }
    String getGreeting() {
      return "Huh? Where am I?";
    }
    
    void study(int hours) {
      _state = _asleep;
    }  
  };
  

  /**
   * Current state of the Roommate.
   * STUDENT TO COMPLETE THE INITIALIZATION (Problem 1.d)
   */
  private AState _state = _asleep;   
  
  //STUDENT TO ADD ANY OTHER NECESSARY FIELDS  (Problem 1.c)
  private Color _eyeColor;
  
  /**
   * Constructor for a Roommate.
   * @param eyeColor  The color of the roommates eyes.
   */
  public Roommate(Color eyeColor) {
    // STUDENT TO COMPLETE (Problem 1.c)
    _eyeColor = eyeColor;
  }
  
  /**
   * Gettor method for the Roommate's eye color
   */
  public Color getEyeColor() {
    // STUDENT TO COMPLETE (Problem 1.c)
    return _eyeColor;
  }
  
  
  public String getGreeting() {
    // STUDENT TO COMPLETE (Problem 1.c)
    return _state.getGreeting();
  } 
  
  public void study(int hours) {
    // STUDENT TO COMPLETE (Problem 1.c)
    _state.study(hours);
  }
  
  public void eat() {
    // STUDENT TO COMPLETE (Problem 1.c)
    _state.eat();
  } 
  
}