 package lrs.visitor;
 import lrs.*;
 
 /**
   * Utility algo to copy the contents of a host list to a given
   * target list
   */
  public class CopyTo implements IAlgo {
    public static final CopyTo Singleton = new CopyTo();
    
    private CopyTo() {}
    
    
    /**
     * Nothing to copy.  Returns the target list.
     * @param targetList[0] The list to which the contents of the host list are copied.
     * @return The target list
     */
    public Object emptyCase(LRStruct host, Object... targetList) {
      // STUDENT TO COMPLETE
      return targetList[0];
    }
    
    
    /**
     * Copies, retaining the order, all the elements of this list 
     * to the target list;
     * @param targetList[0] The list to which the contents of the host list are copied.
     * @return The target list
     */
    public Object nonEmptyCase(LRStruct host, Object... targetList) {
      // STUDENT TO COMPLETE
      return ((LRStruct)host.getRest().execute(this, targetList)).insertFront(host.getFirst());
    }
  };