 package lrs.visitor;
 import lrs.*;
 
 /**
   * Utility algo to count the number of elements in an LRStruct
   * target list
   */
  public class CountElements implements IAlgo {
    public static final CountElements Singleton = new CountElements();
    
    private CountElements() {}
    
    
    /**
     * Zero elements in an empty list 
     * @param nu not used
     * @return 0, always
     */
    public Object emptyCase(LRStruct host, Object... nu) {
      return 0;
    }
    
    
    /**
     * Returns 1 plus the number of elements in the rest of the list
     * @param nu not used
     * @return The number of elements in the lsit
     */
    public Object nonEmptyCase(LRStruct host, Object... targetList) {
      return 1+(Integer)host.getRest().execute(this);
    }
  }