package lrs.visitor.test;
import lrs.*;
import lrs.visitor.*;
import junit.framework.TestCase;


public class Test_CopyTo extends TestCase {
  

  public void test_CopyTo() {
    IAlgo algo = CopyTo.Singleton;
    
    LRStruct src = new LRStruct();
    
    LRStruct target = new LRStruct();
    
    src.execute(algo, target);
    assertEquals("() --> ()", "()", target.toString());
    
    src.insertFront("a");
    target = new LRStruct();
    
    src.execute(algo, target);
    assertEquals("(a) --> ()", "(a)", target.toString());

    src.insertFront("b");
    target = new LRStruct();
    
    src.execute(algo, target);
    assertEquals("(b a) --> ()", "(b a)", target.toString());

    
    src.insertFront("c");
    target = new LRStruct();
    
    src.execute(algo, target);
    assertEquals("(c b a) --> ()", "(c b a)", target.toString());

    src = new LRStruct();
    target = (new LRStruct()).insertFront("z");
    src.execute(algo, target);
    assertEquals("() --> (z)", "(z)", target.toString());
    
    target = new LRStruct();
    target.insertFront("z");

    src.insertFront("a");
    target = (new LRStruct()).insertFront("z");
    
    src.execute(algo, target);
    assertEquals("(a) --> (z)", "(a z)", target.toString());

    src.insertFront("b");
    target = (new LRStruct()).insertFront("z").insertFront("y");
    
    src.execute(algo, target);
    assertEquals("(b a) --> (y z)", "(b a y z)", target.toString());

    
    src.insertFront("c");
    target = (new LRStruct()).insertFront("z").insertFront("y").insertFront("x");
    
    src.execute(algo, target);
    assertEquals("(c b a) --> (x y z)", "(c b a x y z)", target.toString());
  
  }
  
}
